#!/bin/bash
#

#
#передача HTTP запроса
#

#FRequest := "GET http://" + FHost + FPath + " HTTP/1.0"#13#10 +
#                 "Host: " + FHost + #13#10 +
#                 "Authorization: Basic " + EncodeBase64(FUserName + ":" + FPassword) + #13#10 +
#                 "Proxy-Authorization: Basic " + EncodeBase64(FProxyUserName + ":" + FProxyPassword) + #13#10 +
#                 "Proxy-Connection: Keep-Alive" + #13#10 +
#                 "Content-type: application/x-www-form-urlencoded"#13#10#13#10;
#
#Вообще, можно считать что прокси не требует авторизации и слать свой запрос. Если прокси ответит кодом 407, то авторизация нужна, и надо повторить запрос, добавив в него строку наподобие
#"Proxy-Authorization: Basic " + EncodeBase64(FProxyUserName + ":" + FProxyPassword) + #13#10


vversion="01.01"
vdate="01.12.2017"

_url=""
_port=""
_path=""
_Authorization=""
_Proxy_Authorization=""
_Proxy_Connection=""
_Content_type=""
#_User_Agent="Mozilla/4.0 (compatible; MSIE5.01; Windows NT)"
_User_Agent="Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.2) Gecko/20100115 Firefox/3.6 GTB7.1"


function _help()
{
	echo ""
	echo -e "****** \tsndhttp.sh Date:$vdate Version:$vversion - запрос по HTTP ******"
	echo -e "./tsndhttp.sh -str <url> <port> <str>       - посылка строки <str> запроса без формирования по <url> на <port>"
	echo -e "./tsndhttp.sh -get <url:port> <path>        - посылка запроса GET на <url:port>"
	echo -e "./tsndhttp.sh -head <url:port> <path>       - посылка запроса HEAD на <url:port>"
	echo -e "./tsndhttp.sh -options <url:port> <path>    - посылка запроса OPTIONS на <url:port>"
	echo -e "./tsndhttp.sh -trace <url:port> <path>      - посылка запроса TRACE на <url:port>"
	echo ""
}

#GET запрос
function _get()
{
	_met="GET $_path HTTP/1.0\r\n"
	_host="Host: $_url\r\n"
	_agent="User-Agent: $_User_Agent\r\n"
	_snd="$_met$_host$_agent$_Authorization$_Proxy_Authorization$_Proxy_Connection$_Content_type\r\n\r\n"
	rcv=$(echo -e "$_snd" | nc -4 "$_url" "$_port")
	echo -e "$rcv"
}

#HEAD запрос
function _head()
{
	_met="HEAD $_path HTTP/1.0\r\n"
	_host="Host: $_url\r\n"
	_agent="User-Agent: $_User_Agent\r\n"
	_snd="$_met$_host$_agent$_Authorization$_Proxy_Authorization$_Proxy_Connection$_Content_type\r\n\r\n"
	rcv=$(echo -e "$_snd" | nc -4 "$_url" "$_port")
	#sleep 3
	echo -e "$rcv"
}

#OPTIONS запрос
function _options()
{
	_met="OPTIONS $_path HTTP/1.0\r\n"
	_host="Host: $_url\r\n"
	_agent="User-Agent: $_User_Agent\r\n"
	_snd="$_met$_host$_agent$_Authorization$_Proxy_Authorization$_Proxy_Connection$_Content_type\r\n\r\n"
	rcv=$(echo -e "$_snd" | nc -4 "$_url" "$_port")
	#sleep 3
	echo "$rcv"
}

#TRACE запрос
function _trace()
{
	_met="TRACE $_path HTTP/1.0\r\n"
	_host="Host: $_url\r\n"
	_agent="User-Agent: $_User_Agent\r\n"
	_snd="$_met$_host$_agent$_Authorization$_Proxy_Authorization$_Proxy_Connection$_Content_type\r\n\r\n"
	rcv=$(echo -e "$_snd" | nc -4 "$_url" "$_port")
	sleep 3
	echo "$rcv"
}


case $1 in
	"help")
		_help
	;;
	"-str")
		_url=$2
		_port=$3
		str=$4
		rcv=$(echo -e "$str" | nc "$_url" "$_port")
		echo "$rcv"
	;;
	"-get")
		str=$2
		str=$(echo -e "$str" | sed "s/:/ /g")
		_url=$(echo -e "$str" | awk '{print($1)}')
		_port=$(echo -e "$str" | awk '{print($2)}')
		if [ "$_port" == "" ]; then
			_port="80"
		fi
		str=$3
		if [ "$str" == "" ]; then
			_path="/"
		else
			_path=$(echo -e "$str")
		fi
		echo "url:$_url port:$_port path:$_path"
		_get
	;;
	"-get_pa")
		str=$2
		str=$(echo -e "$str" | sed "s/:/ /g")
		_url=$(echo -e "$str" | awk '{print($1)}')
		_port=$(echo -e "$str" | awk '{print($2)}')
		if [ "$_port" == "" ]; then
			_port="80"
		fi
		echo "url:$_url port:$_port"
		str=$3
		if [ "$str" == "" ]; then
			_path="/"
		else
			_path=$(echo -e "$str")
		fi
		echo "path:$_path"
		if [ "$str" == "" ]; then
			_Authorization=$(echo "Authorization: Basic EncodeBase64($str)\r\n")
			_Proxy_Authorization=$(echo "Proxy-Authorization: Basic EncodeBase64($str)\r\n")
			_Proxy_Connection=$(echo "Proxy-Connection: Keep-Alive\r\n")
			_Content_type=$(echo "Content-type: application/x-www-form-urlencoded")
		else
			str=$4
			if [ "$str" != "" ]; then
			_Authorization=$(echo "Authorization: Basic EncodeBase64($str)\r\n")
			_Proxy_Authorization=$(echo "Proxy-Authorization: Basic EncodeBase64($str)\r\n")
			_Proxy_Connection=$(echo "Proxy-Connection: Keep-Alive\r\n")
			_Content_type=$(echo "Content-type: application/x-www-form-urlencoded")
			fi
		fi
		echo -e "$_Authorization$_Proxy_Authorization$_Proxy_Connection"
		_get
	;;
	"-head")
		str=$2
		str=$(echo -e "$str" | sed "s/:/ /g")
		_url=$(echo -e "$str" | awk '{print($1)}')
		_port=$(echo -e "$str" | awk '{print($2)}')
		if [ "$_port" == "" ]; then
			_port="80"
		fi
		echo "url:$_url port:$_port"
		str=$3
		if [ "$str" == "" ]; then
			_path="/"
		else
			_path=$(echo -e "$str")
		fi
		_head
	;;
	"-options")
		str=$2
		_urlport=$(echo -e "$str" | sed "s/:/ /g")
		_url=$(echo -e "$str" | awk '{print($1)}')
		_port=$(echo -e "$str" | awk '{print($2)}')
		if [ "$_port" == "" ]; then
			_port="80"
		fi
		echo "url:$_url port:$_port"
		str=$3
		if [ "$str" == "" ]; then
			_path="/"
		else
			_path=$(echo -e "$str")
		fi
		_options
	;;
	"-trace")
		str=$2
		_urlport=$(echo -e "$str" | sed "s/:/ /g")
		_url=$(echo -e "$str" | awk '{print($1)}')
		_port=$(echo -e "$str" | awk '{print($2)}')
		if [ "$_port" == "" ]; then
			_port="80"
		fi
		echo "url:$_url port:$_port"
		str=$3
		if [ "$str" == "" ]; then
			_path="/"
		else
			_path=$(echo -e "$str")
		fi
		_trace
	;;
	*)
		echo -e ""
		echo -e "примените \"help\" для информации"
		echo -e ""
	;;
esac

